/**********************************************
* Connectmode.c
*     
* : 19.02.2021 10:10:58
* :  .
***********************************************/

// 
#include <avr/io.h>
#include <avr/eeprom.h>
#include "Main.h"
#include "Connectmode.h"
#include "Systemcontrol.h"

EEMEM static word Con_PwmdataCurrent0mA=CONTPWM_CURR0MA; //      
EEMEM static word Con_PwmdataCurrent3ma=CONTPWM_CURR3MA; //      3 
EEMEM static word Con_PwmdataCurrent10ma=CONTPWM_CURR10MA; //      10 
EEMEM static word Con_PwmdataCurrent50ma=CONTPWM_CURR50MA; //      50 

void CON_SwitchDevice(bit indxonoffdevice_prm,byte selecdevice_prm) //     
	{
	switch(selecdevice_prm) // 
		{
		case 0: switch(indxonoffdevice_prm) //    
					{
					case FALSE...TRUE:	CON_SettingCurrent(0); // 
							CONTROL_LMODE=0; //      
							ClearBit(CONTROL_GMODE,CONT_CAPMEASURE); //    1 
							ClearBit(CONTROL_GMODE,CONT_SETTZERO); //   
							SetBit(CONTROL_GMODE,CONT_MULTFREQU); //   
					}
				SYS_TimeWaiting(2); // 2    
				break;
		case 1: switch(indxonoffdevice_prm) //-    
					{
					case FALSE: ClearBit(CONTROL_LMODE,CONT_RESMEASURE); //  
								break;
					case TRUE: SetBit(CONTROL_LMODE,CONT_RESMEASURE); //  
					}
				SYS_TimeWaiting(2); // 2    
				break;
		case 2: switch(indxonoffdevice_prm) //-     
					{
					case FALSE: ClearBit(CONTROL_GMODE,CONT_SETTZERO); // 
								break;
					case TRUE: SetBit(CONTROL_GMODE,CONT_SETTZERO); // 
					}
				SYS_TimeWaiting(2); // 2    
				break;
		case 3: switch(indxonoffdevice_prm) //-    1   
					{
					case FALSE: ClearBit(CONTROL_LMODE,CONT_CAPPMEASURE); //  
								break;
					case TRUE: SetBit(CONTROL_LMODE,CONT_CAPPMEASURE); //  
					}
				SYS_TimeWaiting(2); // 2    
				break;
		case 4: switch(indxonoffdevice_prm) //-   ESR
					{
					case FALSE: ClearBit(CONTROL_LMODE,CONT_ESRMEASURE); // 
								break;
					case TRUE: SetBit(CONTROL_LMODE,CONT_ESRMEASURE); // 
					}
				SYS_TimeWaiting(40); // 40      
				break;
		case 5: switch(indxonoffdevice_prm) //-      ESR
					{
					case FALSE: ClearBit(CONTROL_LMODE,CONT_PRIMDISCH); // 
								break;
					case TRUE:	SetBit(CONTROL_LMODE,CONT_PRIMDISCH); // 
					}
				break;
		case 6: switch(indxonoffdevice_prm) //-      ESR
					{
					case FALSE: ClearBit(CONTROL_LMODE,CONT_SECDISCH); // 
								break;
					case TRUE:	SetBit(CONTROL_LMODE,CONT_SECDISCH); // 
					}
				break;
		case 7: switch(indxonoffdevice_prm) //-      1 
					{
					case FALSE: ClearBit(CONTROL_GMODE,CONT_CAPMEASURE); //  
								break;
					case TRUE: SetBit(CONTROL_GMODE,CONT_CAPMEASURE); //  
					}
				SYS_TimeWaiting(2); // 2    
				break;
		case 8: switch(indxonoffdevice_prm) //-    
					{
					case FALSE: SetBit(CONTROL_GMODE,CONT_MULTFREQU); //  
								break;
					case TRUE: ClearBit(CONTROL_GMODE,CONT_MULTFREQU); //  
					}
				SYS_TimeWaiting(2); // 2    
				break;
		case 9: switch(indxonoffdevice_prm) //-    
					{
					case FALSE: ClearBit(CONTROL_LMODE,CONT_INDMEASURE); //  
								break;
					case TRUE: SetBit(CONTROL_LMODE,CONT_INDMEASURE); //  
					}
				SYS_TimeWaiting(2); // 2    
				break;
		case 10: switch(indxonoffdevice_prm) //-    
			{
			case FALSE: ClearBit(CONTROL_LMODE,CONT_SYMMINPUT); //   
						break;
			case TRUE: SetBit(CONTROL_LMODE,CONT_SYMMINPUT); //   
			}
		SYS_TimeWaiting(2); // 2    
		}
	}

void CON_SettingCurrent(byte numberpwmdata_prm) //  
	{
	word currentdata_tmp=0; // 
	switch(numberpwmdata_prm) //  
		{
		case 0: currentdata_tmp=eeprom_read_word(&Con_PwmdataCurrent0mA); //    
				break;
		case 1: currentdata_tmp=eeprom_read_word(&Con_PwmdataCurrent3ma); //    
				break;
		case 2: currentdata_tmp=eeprom_read_word(&Con_PwmdataCurrent10ma); //    10 
				break;
		case 3: currentdata_tmp=eeprom_read_word(&Con_PwmdataCurrent50ma); //    50 
		}
	OCR2B=(byte)currentdata_tmp; //     
	SYS_TimeWaiting(50); // 50    
	}

void CON_ResistanceMode(void) //     
	{
	CON_SwitchDevice(FALSE,0); // 
	CON_SwitchDevice(TRUE,1); //  
	}

void CON_CappacityMode(void) //      1   
	{
	CON_SwitchDevice(FALSE,0); //  
	CON_SwitchDevice(TRUE,5); //  
	CON_SwitchDevice(TRUE,3); //    
	CON_SettingCurrent(1); //  
	}

void CON_CapacityMode(void) //       1 
	{
	CON_SwitchDevice(FALSE,0); //  
	CON_SwitchDevice(TRUE,7); //    
	}

void CON_InductanceMode(void) //     
	{
	CON_SwitchDevice(FALSE,0); //  
	CON_SwitchDevice(TRUE,6); //  
	CON_SettingCurrent(1); //  
	}

void CON_RefresCalibrate(void) //       
	{
	CON_SwitchDevice(FALSE,0); //  
	CON_SwitchDevice(TRUE,5); //  
	CON_SettingCurrent(1); //  
	}

void CON_FrequpiezoCalibrate(void) //       
	{
	CON_SwitchDevice(FALSE,0); //  
	CON_SwitchDevice(TRUE,5); //  
	CON_SettingCurrent(1); //  
	}

void CON_Curr3maCalibrate(void) //      3 
	{
	CON_SwitchDevice(FALSE,0); //  
	CON_SwitchDevice(TRUE,5); //  
	CON_SwitchDevice(TRUE,4); //  ESR
	CON_SwitchDevice(TRUE,10); //   
	CON_SettingCurrent(1); //  3   
	CON_SwitchDevice(FALSE,5); //  
	}

void CON_Curr10maCalibrate(void) //      10 
	{
	CON_SwitchDevice(FALSE,0); //  
	CON_SwitchDevice(TRUE,5); //  
	CON_SwitchDevice(TRUE,4); //  ESR
	CON_SwitchDevice(TRUE,10); //   
	CON_SettingCurrent(2); //  10   
	CON_SwitchDevice(FALSE,5); //  
	}

void CON_Curr50maCalibrate(void) //      50 
	{
	CON_SwitchDevice(FALSE,0); //  
	CON_SwitchDevice(TRUE,5); //  
	CON_SwitchDevice(TRUE,4); //  ESR
	CON_SwitchDevice(TRUE,10); //   
	CON_SettingCurrent(3); //  50   
	CON_SwitchDevice(FALSE,5); //  
	}

void CON_WritePwmdata(byte numberpwmdata_prm,word actualpwmdata_prm) //   
	{
	switch(numberpwmdata_prm) //  
		{
		case 1: eeprom_update_word(&Con_PwmdataCurrent3ma,actualpwmdata_prm); //     3 
				break;
		case 2: eeprom_update_word(&Con_PwmdataCurrent10ma,actualpwmdata_prm); //     10 
				break;
		case 3: eeprom_update_word(&Con_PwmdataCurrent50ma,actualpwmdata_prm); //     50 
		}
	CON_SettingCurrent(numberpwmdata_prm); //  
	}

word CON_ReadPwmdata(byte numberpwmdata_prm) //   
	{
	word actualpwmdata_tmp=0; // 
	switch(numberpwmdata_prm) //  
		{
		case 1: actualpwmdata_tmp=eeprom_read_word(&Con_PwmdataCurrent3ma); //     3 
				break;
		case 2: actualpwmdata_tmp=eeprom_read_word(&Con_PwmdataCurrent10ma); //     10 
				break;
		case 3: actualpwmdata_tmp=eeprom_read_word(&Con_PwmdataCurrent50ma); //     50 
		}
	return actualpwmdata_tmp; //  
	}


















