/**********************************************
* Indmeasure.c
*    
* : 19.02.2021 17:09:37
* :  .
***************************************************/

// 
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <math.h>
#include "Main.h"
#include "Indmeasure.h"
#include "Capmeasure.h"
#include "Adconverter.h"
#include "Outmessage.h"
#include "Connectmode.h"
#include "Systemcontrol.h"
#include "Symbolcharge.h"
#include "Esrmeasure.h"
#include "Resmeasure.h"

bit_ind indx_ind={0,0,0,0,0,0,0,0,0}; // 
var_ind alter_ind={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; // 

EEMEM static dword Ind_SupportCapacity=INDSUPPORT_CAPACITY; //   
EEMEM static dword Ind_OffsetInductance=INDOFFSET_INDUCTANCE; //    
EEMEM static dword Ind_ProbeInductance=INDPROBE_INDUCTANCE; //    

void IND_ConstantaMeasure(void) //   
	{
	dword supportcapacity_tmp=0; // 
	floatpoint calculationdata_tmp=0;
	supportcapacity_tmp=eeprom_read_dword(&Ind_SupportCapacity); //   
	calculationdata_tmp=2000000*M_PI; //   
	alter_ind.constantadataquality=(ldword)calculationdata_tmp; //      
	calculationdata_tmp=2*M_PI*(floatpoint)supportcapacity_tmp*INDFREQU_CRYSTAL*INDRATIO_TIMER0; //    
	alter_ind.constantadatameasure=(ldword)calculationdata_tmp; //      
	alter_ind.constantadatafrequency=INDFREQU_CRYSTAL; //   
	alter_ind.constantadatafrequency*=INDRATIO_TIMER0; //    
	alter_ind.supportinductance=CAP_ReadsupportInductance(); //   
	alter_ind.proberesistance=RES_ReadProberesistance()/10; //    
	}

byte IND_ReadCursorposition(bit indxplaceposition_prm) //     
	{
	byte cursorposition_tmp=0; // 
	switch(indxplaceposition_prm)
		{
		case FALSE: cursorposition_tmp=alter_ind.spotpositioncursor; //     
					break;
		case TRUE: cursorposition_tmp=alter_ind.linepositioncursor; //    
		}
	return cursorposition_tmp; //     
	}

void IND_ModeMeasure(bit initializemode_prm) //    
	{
	IND_DisplayResultmeasure(initializemode_prm); //   
	IND_CycleMeasure(); //  
	}

dword IND_DecoderLimitmeasure(ldword measuredvalue_prm,byte limitingvalue_prm) //   
	{
	ldword inductancedata_tmp; // 
	inductancedata_tmp=measuredvalue_prm;
	while(inductancedata_tmp>9999) //   
		{
		if(alter_ind.countlimitmeasure<limitingvalue_prm) //    
			{
			alter_ind.countlimitmeasure++; //  
			inductancedata_tmp/=10; //   10 
			}
		else break; //      
		}
	return (dword)inductancedata_tmp; //    
	}

void IND_DisplayResultmeasure(bit initializemode_prm) //    
	{
	dword extrameasuredata_tmp=0; // 
	if((indx_ind.displaydatameasure==FALSE)&&(initializemode_prm==TRUE)) indx_ind.displaydatameasure=TRUE; //     
	if(indx_ind.displaydatameasure==TRUE) //      
		{
		indx_ind.displaydatameasure=FALSE; // 
		if(initializemode_prm==TRUE) indx_ind.initializeindmode=TRUE; //      
		if((indx_ind.initializeindmode==TRUE)||(alter_ind.countlimitmeasure!=alter_ind.backuplimitmeasure)) //   
			{
			IND_InicializeLineview(); //     
			}
		IND_MeasureDataview(); //   
		switch(alter_ind.countlineposition) //   
					{
					case 0 ... 1: switch(alter_ind.countlineaddition) //        
								{
								case 0: SYM_OutdataMeasure000000((dword)alter_ind.measuredatafrequency,7,1); //  
										break;
								case 1: SYM_OutdataMeasure0000_000(alter_ind.measuredataperiod,7,12,1); //  
										break;
								case 2: SYM_OutdataMeasure00000_0(alter_ind.qualitydatainductance,7,13,1); //  
								}
							break;
					case 2: extrameasuredata_tmp=eeprom_read_dword(&Ind_OffsetInductance); //       
							SYM_OutdataMeasure000_00(extrameasuredata_tmp,12,16,1); //   
							break;
					case 3: extrameasuredata_tmp=eeprom_read_dword(&Ind_ProbeInductance); //          
							SYM_OutdataMeasure00_00(extrameasuredata_tmp,12,15,1); //    
							break;
					case 4: extrameasuredata_tmp=eeprom_read_dword(&Ind_SupportCapacity); //        
							SYM_OutdataMeasure00000_0(extrameasuredata_tmp,12,18,1); //   
					}
		if(alter_ind.countlimitmeasure>0) alter_ind.countlimitmeasure=0; //     
		}
	indx_ind.pinchiptypedevice=SYS_ReadtypePinchip(); //    pin/chip
	OUT_PinchipType(indx_ind.pinchiptypedevice); //  
	}

void IND_InicializeLineview(void) //      
	{
	if(indx_ind.initializeindmode==TRUE) indx_ind.initializeindmode=FALSE; // 
	if(alter_ind.countlimitmeasure!=alter_ind.backuplimitmeasure) alter_ind.backuplimitmeasure=alter_ind.countlimitmeasure; //      
	switch(indx_ind.inductancereactive) //  /
		{
		case FALSE: switch(alter_ind.backuplimitmeasure)  //    
						{
						case 0: SYM_OutcharLine(4,0,0); // : L=  ,   
								break;
						case 1: SYM_OutcharLine(4,1,0); // : L=   ,  
								break;
						case 2: SYM_OutcharLine(4,2,0); // : L= ,    
								break;
						case 3: SYM_OutcharLine(4,3,0); // : L=  ,   
								break;
						case 4: SYM_OutcharLine(4,4,0); // : L=   ,  
								break;
						case 5: SYM_OutcharLine(4,5,0); // : L= ,    
								break;
						case 6: SYM_OutcharLine(4,6,0); // : L=  ,   
						}
					break;
		case TRUE: switch(alter_ind.backuplimitmeasure) //     
						{
						case 0: SYM_OutcharLine(3,5,0); // : X= ,    
								break;
						case 1: SYM_OutcharLine(2,5,0); // : X=  ,   
								break;
						case 2: SYM_OutcharLine(2,6,0); // : X=   ,  
								break;
						case 3: SYM_OutcharLine(3,6,0); // : X= ,    
								break;
						case 4: SYM_OutcharLine(3,7,0); // : X=  ,   
						}
		}
	}

void IND_MeasureDataview(void) //    
	{
	switch(indx_ind.inductancereactive) // /
		{
		case FALSE:	switch(alter_ind.backuplimitmeasure) //   
						{
						case 0: SYM_OutdataMeasure00_00(alter_ind.measuredatainductance,7,10,0); //     00,00
								break;
						case 1: SYM_OutdataMeasure000_0(alter_ind.measuredatainductance,7,11,0); //     000,0
								break;
						case 2: SYM_OutdataMeasure0_000(alter_ind.measuredatainductance,7,9,0); //     0,000
								break;
						case 3: SYM_OutdataMeasure00_00(alter_ind.measuredatainductance,7,10,0); //     00,00
								break;
						case 4: SYM_OutdataMeasure000_0(alter_ind.measuredatainductance,7,11,0); //     000,0
								break;
						case 5: SYM_OutdataMeasure0_000(alter_ind.measuredatainductance,7,9,0); //     0,000
								break;
						case 6: SYM_OutdataMeasure00_00(alter_ind.measuredatainductance,7,10,0); //     00,00
						}
					break;
		case TRUE: switch(alter_ind.backuplimitmeasure) //   
						{
						case 0: SYM_OutdataMeasure0_000(alter_ind.measuredatareactive,7,9,0); //     0,000
								break;
						case 1: SYM_OutdataMeasure00_00(alter_ind.measuredatareactive,7,10,0); //     00,00
								break;
						case 2: SYM_OutdataMeasure000_0(alter_ind.measuredatareactive,7,11,0); //     000,0
								break;
						case 3: SYM_OutdataMeasure0_000(alter_ind.measuredatareactive,7,9,0); //     0,000
								break;
						case 4: SYM_OutdataMeasure00_00(alter_ind.measuredatareactive,7,10,0); //     00,00
						}
		}
	}

void IND_CycleMeasure(void) //   
	{
	ldword inductancedata_tmp=0; // 
	ldword reactivedata_tmp=0;
	if((indx_ind.readydatameasure==FALSE)&&(indx_ind.startcyclemeasure==FALSE)) //   
		{
		if(IND_DetectInductance()==TRUE) //    
			{
			if(SYS_ReadindxOnoffaudio()>0) SYS_OutsignalBeep(1); //    1 ,  
			indx_ind.startcyclemeasure=TRUE; //   
			CON_SwitchDevice(TRUE,9); //   
			SYS_TimeWaiting(50); //   
			SYS_InitializeVariable(); //   
			SYS_SwitchBlockmode(TRUE); //  
			IND_InicializeVariable(); //  
			SYM_IndicationMeasure(TRUE); //  
			IND_StartstopMeasure(TRUE); //  
			}
		else if((alter_ind.measuredatainductance>0)||(alter_ind.measuredatafrequency>0)) //   
			{
			if(alter_ind.measuredatainductance>0) alter_ind.measuredatainductance=0; //     
			if(alter_ind.measuredatafrequency>0) alter_ind.measuredatafrequency=0; //     
			if(alter_ind.qualitydatainductance>0) alter_ind.qualitydatainductance=0; //     
			indx_ind.displaydatameasure=TRUE; //   
			}
		} 
	else if((indx_ind.readydatameasure==TRUE)&&(indx_ind.startcyclemeasure==TRUE)) //   
		{
		IND_StartstopMeasure(FALSE); //  
		indx_ind.readydatameasure=FALSE; //   
		indx_ind.startcyclemeasure=FALSE; //   
		indx_ind.displaydatameasure=TRUE; //   
		SYM_IndicationMeasure(FALSE); //  
		SYS_SwitchBlockmode(FALSE); //  
		CON_SwitchDevice(FALSE,9); //   
		if(indx_ind.datatimeoverflow==FALSE) inductancedata_tmp=IND_ProcessMeasure(); //     
		if(inductancedata_tmp>0) reactivedata_tmp=IND_CalculationReactive(inductancedata_tmp); //       
		switch(indx_ind.inductancereactive) // /
			{
			case FALSE: alter_ind.measuredatainductance=IND_DecoderLimitmeasure(inductancedata_tmp,6); //   
						break;
			case TRUE:  alter_ind.measuredatareactive=IND_DecoderLimitmeasure(reactivedata_tmp,4); //   
			}
		}
	}

bit IND_DetectInductance(void) //     
	{
	bit indxdetectinductance_tmp=FALSE; // 
	word measuredatavoltage_tmp=0;
	if(indx_ind.switchingcurrent==FALSE) //     
		{
		indx_ind.switchingcurrent=TRUE; // 
		CON_SwitchDevice(TRUE,10); //    
		CON_SwitchDevice(TRUE,4); //  
		CON_SwitchDevice(FALSE,6); //  
		SYS_TimeWaiting(100); // 100    
		}
	measuredatavoltage_tmp=ADC_AverageSymmdata(TRUE,5,ADCSYMM1X_12INPUT); //    Vdd 
	if(measuredatavoltage_tmp<4500)  //   
		{
		SYS_TimeWaiting(20); // 20 
		measuredatavoltage_tmp=ADC_AverageSymmdata(TRUE,50,ADCSYMM1X_12INPUT); //    Vdd 
		if(measuredatavoltage_tmp<4500) //    
			{
			IND_ResistanceInductance(measuredatavoltage_tmp); //    
			CON_SwitchDevice(FALSE,10); //    
			CON_SwitchDevice(TRUE,6); //  
			CON_SwitchDevice(FALSE,4); //  
			indx_ind.switchingcurrent=FALSE; //    
			indxdetectinductance_tmp=TRUE; //     
			}
		}
	return indxdetectinductance_tmp; //   
	}

void IND_ResistanceInductance(word measuredatavoltage_prm) //      
	{
	bit indxlimitselected_tmp=FALSE; // 
	byte countlimitmeasure_tmp=0;
	dword measuredatavoltage_tmp=0;
	dword electricalcurrent_tmp=0;
	while(indxlimitselected_tmp==FALSE) //    
		{
		countlimitmeasure_tmp++; //  
		switch(countlimitmeasure_tmp) // 
			{
			case 1: if(measuredatavoltage_prm>=1000) //     1   
						{
						measuredatavoltage_tmp=(dword)measuredatavoltage_prm; //  
						electricalcurrent_tmp=(dword)ESR_ReadCurrent(0); //     3 
						alter_ind.resistanceinductance=measuredatavoltage_tmp*100000/electricalcurrent_tmp; //   
						indxlimitselected_tmp=TRUE; //    
						}
					break;
			case 2: measuredatavoltage_tmp=(dword)ADC_AverageSymmdata(FALSE,50,ADCSYMM1X_12INPUT); //       1   1,1 
					if(measuredatavoltage_tmp>=100) //     100   
						{
						electricalcurrent_tmp=(dword)ESR_ReadCurrent(0); //     3 
						alter_ind.resistanceinductance=measuredatavoltage_tmp*100000/electricalcurrent_tmp; //   
						indxlimitselected_tmp=TRUE; //     
						}
					break;
			case 3: measuredatavoltage_tmp=(dword)ADC_AverageSymmdata(FALSE,50,ADCSYMM10X_10INPUT); //       10   1,1 
					if(measuredatavoltage_tmp>=268) //     268   
						{
						electricalcurrent_tmp=(dword)ESR_ReadCurrent(0); //     3 
						alter_ind.resistanceinductance=measuredatavoltage_tmp*10000/electricalcurrent_tmp; //   
						indxlimitselected_tmp=TRUE; //     
						}
					break;
			case 4: CON_SettingCurrent(2); //   10 
					SYS_TimeWaiting(50); // 50 
					measuredatavoltage_tmp=(dword)ADC_AverageSymmdata(FALSE,50,ADCSYMM10X_10INPUT); //       10   1,1 
					if(measuredatavoltage_tmp>=200) //     200   
						{
						electricalcurrent_tmp=(dword)ESR_ReadCurrent(1); //     10 
						alter_ind.resistanceinductance=measuredatavoltage_tmp*10000/electricalcurrent_tmp; //   
						indxlimitselected_tmp=TRUE; //     
						}
					CON_SettingCurrent(1); //   3 
					break;
			case 5: CON_SettingCurrent(3); //   50 
					SYS_TimeWaiting(50); // 50 
					measuredatavoltage_tmp=(dword)ADC_AverageSymmdata(FALSE,50,ADCSYMM10X_10INPUT); //       10   1,1 
					if(measuredatavoltage_tmp>=5) //     5   
						{
						electricalcurrent_tmp=(dword)ESR_ReadCurrent(2); //     50 
						alter_ind.resistanceinductance=measuredatavoltage_tmp*10000/electricalcurrent_tmp; //   
						indxlimitselected_tmp=TRUE; //     
						}
					CON_SettingCurrent(1); //   3 
					break;
			case 6: alter_ind.resistanceinductance=0; //   
					indxlimitselected_tmp=TRUE; //      
			}
		}
	}

void IND_InicializeVariable(void) //   
	{
	if(indx_ind.readydatameasure==TRUE) indx_ind.readydatameasure=FALSE; //      
	if(indx_ind.datatimeoverflow==TRUE) indx_ind.datatimeoverflow=FALSE; //    
	if(alter_ind.countoverflowtimer>0) alter_ind.countoverflowtimer=0; //     
	if(alter_ind.countintervalmeasure>0) alter_ind.countintervalmeasure=0; //      
	}

void IND_StartstopMeasure(bit indxstartstop_prm) //     
	{
	switch(indxstartstop_prm) // /
		{
		case FALSE: cli(); //  
					ClearBit(TIMSK0,TOIE0); //     0
					ClearBit(TIMSK1,TOIE1); //    1
					break;
		case TRUE: TCNT0=250; // 0
					TCNT1=0; // 1
					TCCR0B=6; //  0      
					SetBit(TIMSK0,TOIE0); //    0
					sei(); //  
		}
	}

void IND_ReadMeasuredata(bit readydatameasure_prm,bit datatimeoverflow_prm,word countintervalmeasure_prm,dword countoverflowtimer_prm) //   
	{
	indx_ind.readydatameasure=readydatameasure_prm; //    
	indx_ind.datatimeoverflow=datatimeoverflow_prm; //  
	alter_ind.countintervalmeasure=countintervalmeasure_prm; //   
	alter_ind.countoverflowtimer=countoverflowtimer_prm; //   
	}

ldword IND_ProcessMeasure(void) //    
	{
	ldword offsetinductance_tmp=0; // 
	ldword inductancedata_tmp=0;
	inductancedata_tmp=IND_ResultsMeasure(); //   
	if(indx_ind.writeoffsetinductance==TRUE) //     
		{
		indx_ind.writeoffsetinductance=FALSE; // 
		if(inductancedata_tmp>=alter_ind.supportinductance) offsetinductance_tmp=inductancedata_tmp; //      
		else offsetinductance_tmp=(ldword)alter_ind.supportinductance-((ldword)alter_ind.supportinductance-inductancedata_tmp); //      
		eeprom_update_dword(&Ind_OffsetInductance,(dword)offsetinductance_tmp); //  
		}
	if(indx_ind.pinchiptypedevice==TRUE) //   
		{
		inductancedata_tmp-=eeprom_read_dword(&Ind_ProbeInductance); //   
		if(alter_ind.proberesistance<alter_ind.resistanceinductance) alter_ind.resistanceinductance-=alter_ind.proberesistance; //   
		else alter_ind.resistanceinductance=alter_ind.proberesistance-alter_ind.resistanceinductance;
		if(alter_ind.resistanceinductance==0) alter_ind.resistanceinductance++; //     
		}
	if(inductancedata_tmp>(eeprom_read_dword(&Ind_OffsetInductance)+5)) //       0,05 
		{
		inductancedata_tmp-=eeprom_read_dword(&Ind_OffsetInductance); //     
		alter_ind.qualitydatainductance=IND_QualityInductance(inductancedata_tmp); //  
		}
	else //        
		{
		inductancedata_tmp=0; //  
		if(alter_ind.qualitydatainductance>0) alter_ind.qualitydatainductance=0; //  
		}
	return inductancedata_tmp; //  
	}

ldword IND_ResultsMeasure(void) //   
	{
	ldword inductancedata_tmp=0; // 
	ldword measuredataperiod_tmp=0;
	if(alter_ind.countoverflowtimer>0) measuredataperiod_tmp=INDRATIO_TIMER1*alter_ind.countoverflowtimer; //  
	measuredataperiod_tmp+=(ldword)TCNT1; //   1
	alter_ind.measuredatafrequency=IND_CalculationFrequency(measuredataperiod_tmp); //    
	alter_ind.measuredataperiod=IND_CalculationPeriod(); //  
	inductancedata_tmp=IND_CalculationInductance(measuredataperiod_tmp); //  
	return inductancedata_tmp; //  
	}

ldword IND_CalculationFrequency(ldword measuredataperiod_prm) //   
	{
	ldword measuredatafrequency_tmp=0; // 
	measuredatafrequency_tmp=alter_ind.constantadatafrequency; //     
	measuredatafrequency_tmp*=alter_ind.countintervalmeasure; //      
	measuredatafrequency_tmp/=measuredataperiod_prm; //  
	return measuredatafrequency_tmp; //  
	}

dword IND_CalculationPeriod(void) //   
	{
	ldword calculationperiod_tmp=0; // 
	calculationperiod_tmp=1000000000/alter_ind.measuredatafrequency; // 
	return (dword)calculationperiod_tmp; //  
	}

ldword IND_CalculationInductance(ldword measuredataperiod_prm) //  
	{
	dword capacitydata_tmp=0; // 
	ldword calculationinductance_tmp=0;
	ldword frequencydata_tmp=0;
	floatpoint intermediatedata_tmp=0;
	frequencydata_tmp=IND_CalculationFrequency(measuredataperiod_prm); // 
	capacitydata_tmp=eeprom_read_dword(&Ind_SupportCapacity); //   
	intermediatedata_tmp=2*M_PI*(floatpoint)frequencydata_tmp; //  
	intermediatedata_tmp*=intermediatedata_tmp; //   
	intermediatedata_tmp/=1000; //  
	intermediatedata_tmp*=(floatpoint)capacitydata_tmp; // 
	calculationinductance_tmp=1000000000000000000/(ldword)intermediatedata_tmp; //  
	return calculationinductance_tmp; //  
	}

dword IND_CalculationReactive(ldword inductancedata_prm) //    
	{
	floatpoint intermediatedata_tmp=0; // 
	ldword reactivedata_tmp=0;
	intermediatedata_tmp=2*M_PI*(floatpoint)alter_ind.measuredatafrequency*(floatpoint)inductancedata_prm; //  
	reactivedata_tmp=(ldword)intermediatedata_tmp/100000; // 
	return (dword)reactivedata_tmp;
	}

dword IND_QualityInductance(ldword inductancedata_prm) //   
	{
	floatpoint intermediatedata_tmp=0; // 
	ldword qualityinductance_tmp=0;
	ldword resistanceinductance_tmp=0;
	ldword reactiveinductance_tmp=0;
	intermediatedata_tmp=(floatpoint)alter_ind.measuredatafrequency; //     
	intermediatedata_tmp=sqrt(intermediatedata_tmp); //    
	resistanceinductance_tmp=(ldword)intermediatedata_tmp*alter_ind.resistanceinductance/1000+alter_ind.resistanceinductance; //    
	reactiveinductance_tmp=alter_ind.constantadataquality*alter_ind.measuredatafrequency; //  
	reactiveinductance_tmp/=10000000; // 
	reactiveinductance_tmp=reactiveinductance_tmp*inductancedata_prm; //   
	qualityinductance_tmp=reactiveinductance_tmp/(resistanceinductance_tmp*10000); //  
	return (dword)qualityinductance_tmp; // 
	}

void IND_ControlModemeasure(byte readoutcode_prm) //      
	{
	switch(readoutcode_prm) //   
		{
		case 1: switch(alter_ind.countlineposition) //       Left
					{
					case 0: if(alter_ind.countspotposition==0) alter_ind.countspotposition=1; //      
							else alter_ind.countspotposition=0; //   
							break;
					case 1: asm("nop"); // 
							break;
					case 2: if(alter_ind.countspotposition==1) alter_ind.countspotposition=2; //  2   1     
							else alter_ind.countspotposition=1; //  1   2
							break;
					case 3: if(alter_ind.countspotposition>1) alter_ind.countspotposition--; //           1
							else alter_ind.countspotposition=4; //  4     1
							break;
					case 4: if(alter_ind.countspotposition>1) alter_ind.countspotposition--; //          1
							else alter_ind.countspotposition=4; //  4     1
					}
				break;
		case 2: switch(alter_ind.countlineposition) //       Rigt
					{
					case 0: if(alter_ind.countspotposition==0) alter_ind.countspotposition=1; //      
							else alter_ind.countspotposition=0; //   
							break;
					case 1: asm("nop"); // 
							break;
					case 2: if(alter_ind.countspotposition==1) alter_ind.countspotposition=2; //  2   1     
							else alter_ind.countspotposition=1; //  1   2
							break;
					case 3: alter_ind.countspotposition++; //        
							if(alter_ind.countspotposition>4) alter_ind.countspotposition=1; //  1     4
							break;
					case 4: alter_ind.countspotposition++; //       
							if(alter_ind.countspotposition>4) alter_ind.countspotposition=1; //  1     4
					}
				break;
		case 3: if(alter_ind.countspotposition==1) //      Up
					{
					if(alter_ind.countlineaddition==0) //   
						{
						alter_ind.countlineposition++; //  
						if(alter_ind.countlineposition>4) alter_ind.countlineposition=0; //    4
						IND_UpdateVariantline(); // 
						}
					else asm("nop"); //       
					}
				else IND_CorrectCalibratedata(FALSE); //   
				break;
		case 4: if(alter_ind.countspotposition==1) //      Down
					{
					if(alter_ind.countlineaddition==0) //   
						{
						if(alter_ind.countlineposition>0) alter_ind.countlineposition--; //     
						else alter_ind.countlineposition=4; //   4  
						IND_UpdateVariantline(); // 
						}
					else asm("nop"); //       
					}
				else IND_CorrectCalibratedata(TRUE); //   
				break;
		case 5: switch(alter_ind.countlineposition) //       Enter
					{
					case 0: if(indx_ind.inductancereactive==FALSE) indx_ind.inductancereactive=TRUE; //    
							else indx_ind.inductancereactive=FALSE; //    
							indx_ind.initializeindmode=TRUE; //      
							break;
					case 1: alter_ind.countlineaddition++; //   
							if(alter_ind.countlineaddition>2) alter_ind.countlineaddition=0; //     
							switch(alter_ind.countlineaddition)
								{
								case 0: SYM_OutcharLine(0,5,1); // : F=       
										break;
								case 1: SYM_OutcharLine(0,7,1); // : T=    ,    
										break;
								case 2: SYM_OutcharLine(2,9,1); // : Q=     ,
								}
							break;
					case 2: if((indx_ind.writeoffsetinductance==FALSE)&&(alter_ind.countspotposition==2)) indx_ind.writeoffsetinductance=TRUE; //     
							else asm("nop"); // 
							break;
					case 3 ... 4: asm("nop"); // 
					}
		}
	indx_ind.displaydatameasure=TRUE; //   
	switch(alter_ind.countlineposition) //  
		{
		case 0: alter_ind.linepositioncursor=0; //   
				switch(alter_ind.countspotposition) //   
					{
					case 0: alter_ind.spotpositioncursor=0; //        
							break;
					case 1: alter_ind.spotpositioncursor=5; //         /
					}
				break;
		case 1: alter_ind.linepositioncursor=1; //   
				alter_ind.spotpositioncursor=5; //       /
				break;
		case 2: alter_ind.linepositioncursor=1; //   
				switch(alter_ind.countspotposition) //   
					{
					case 1: alter_ind.spotpositioncursor=9; //      
							break;
					case 2: alter_ind.spotpositioncursor=12; //      
					}
				break;
		case 3: alter_ind.linepositioncursor=1; //   
				switch(alter_ind.countspotposition) //       
					{
					case 1: alter_ind.spotpositioncursor=9; //    
							break;
					case 2: alter_ind.spotpositioncursor=13; //    
							break;
					case 3: alter_ind.spotpositioncursor=15; //     
							break;
					case 4: alter_ind.spotpositioncursor=16; //     
					}
				break;
		case 4: alter_ind.linepositioncursor=1; //   
				switch(alter_ind.countspotposition) //      
					{
					case 1: alter_ind.spotpositioncursor=9; //    
							break;
					case 2: alter_ind.spotpositioncursor=14; //    
							break;
					case 3: alter_ind.spotpositioncursor=15; //    
							break;
					case 4: alter_ind.spotpositioncursor=16; //    
					}
		}
	}

void IND_UpdateVariantline(void) //   
	{
	switch(alter_ind.countlineposition) // 
		{
		case 0 ... 1: SYM_OutcharLine(0,5,1); // : F=       
				break;
		case 2: SYM_OutcharLine(4,7,1); // : .L0    ,   
				break;
		case 3: SYM_OutcharLine(4,8,1); // : .Lp   ,   
				break;
		case 4: SYM_OutcharLine(4,9,1); // : .C      ,  
		}
	}

void IND_CorrectCalibratedata(bit indxincdecdata_prm) //   
	{
	switch(alter_ind.countlineposition) // 
		{
		case 0 ... 2: asm("nop"); // 
				break;
		case 3: IND_CorrectProbeinductance(indxincdecdata_prm); //    
				break;
		case 4: IND_CorrectsupportCapacity(indxincdecdata_prm); //   
		}
	}

void IND_CorrectProbeinductance(bit indxincdecdata_prm) //     
	{
	dword inductancedata_tmp=0; // 
	inductancedata_tmp=eeprom_read_dword(&Ind_ProbeInductance); //    
	switch(alter_ind.countspotposition) //   
		{
		case 1: asm("nop"); // 
				break;
		case 2: if(indxincdecdata_prm==FALSE) inductancedata_tmp+=100; //   100   
				else if((indxincdecdata_prm==TRUE)&&(inductancedata_tmp>100)) inductancedata_tmp-=100; //   100   
				break;
		case 3: if(indxincdecdata_prm==FALSE) inductancedata_tmp+=10; //   10   
				else if((indxincdecdata_prm==TRUE)&&(inductancedata_tmp>10)) inductancedata_tmp-=10; //   10   
				break;
		case 4: if(indxincdecdata_prm==FALSE) inductancedata_tmp+=1; //   1   
				else if((indxincdecdata_prm==TRUE)&&(inductancedata_tmp>1)) inductancedata_tmp-=1; //   1   
		}
	eeprom_update_dword(&Ind_ProbeInductance,inductancedata_tmp); //    
	}

void IND_CorrectsupportCapacity(bit indxincdecdata_prm) //    
	{
	dword capacitydata_tmp=0; // 
	capacitydata_tmp=eeprom_read_dword(&Ind_SupportCapacity); //   
	switch(alter_ind.countspotposition) //   
		{
		case 1: asm("nop"); // 
				break;
		case 2: if(indxincdecdata_prm==FALSE) capacitydata_tmp+=1000; //   1000   
				else if((indxincdecdata_prm==TRUE)&&(capacitydata_tmp>1000)) capacitydata_tmp-=1000; //   1000   
				break;
		case 3: if(indxincdecdata_prm==FALSE) capacitydata_tmp+=100; //   100   
				else if((indxincdecdata_prm==TRUE)&&(capacitydata_tmp>100)) capacitydata_tmp-=100; //   100   
				break;
		case 4: if(indxincdecdata_prm==FALSE) capacitydata_tmp+=10; //   10   
				else if((indxincdecdata_prm==TRUE)&&(capacitydata_tmp>10)) capacitydata_tmp-=10; //   10   
		}
	eeprom_update_dword(&Ind_SupportCapacity,capacitydata_tmp); //   
	IND_ConstantaMeasure(); // 
	}

dword IND_ReadsupportCapacity(void) //    
	{
	dword supportcapacity_tmp=0; // 
	supportcapacity_tmp=eeprom_read_dword(&Ind_SupportCapacity); //   
	return supportcapacity_tmp; //   
	}




















