/*******************************************************
 * Lcdworkunit.c
 *     LCD  DV24200
 * : 10.10.2018 13:54:01
 * :  .
 *******************************************************/

#include <avr/io.h>
#include <util/delay_basic.h>
#include "Lcdworkunit.h"
#include "Systemcontrol.h"

void LCD_CommonFunction(byte numberdata_prm) //      LCD  4- 
	{
	byte numberdata_tmp=0; // 
	numberdata_tmp=LCDPORT_DATA&15; //      
	numberdata_tmp|=(numberdata_prm&240); //      
	LCDPORT_DATA=numberdata_tmp; //     LCD
	SetBit(LCDPORT_DATA,LCDIN_BITEN); //     LCD
	_delay_loop_2(8); //  2 
	ClearBit(LCDPORT_DATA,LCDIN_BITEN); // 
	numberdata_prm=LCD_SwapNibbles(numberdata_prm); //    
	numberdata_tmp=LCDPORT_DATA&15; //      
	numberdata_tmp|=(numberdata_prm&240); //      
	LCDPORT_DATA=numberdata_tmp; //     LCD
	SetBit(LCDPORT_DATA,LCDIN_BITEN); //     LCD
	_delay_loop_2(8); //  2 
	ClearBit(LCDPORT_DATA,LCDIN_BITEN); // 
	}

void LCD_WaitDevice(void) //   LCD
	{
	byte numberdata_tmp=0; // 
	LCDPORT_DIRECT&=15; //  4-    
	LCDPORT_DATA|=240; //     4- 
	SetBit(LCDPORT_DATA,LCDOUT_BITRW); //    LCD
	ClearBit(LCDPORT_DATA,LCDOUT_BITRS); //    LCD
	do //   LCD
		{
		SetBit(LCDPORT_DATA,LCDIN_BITEN);	//  
		_delay_loop_2(8); //  2 
		numberdata_tmp=PINK&240; //      LCD
		ClearBit(LCDPORT_DATA,LCDIN_BITEN); //  
		numberdata_tmp=LCD_SwapNibbles(numberdata_tmp); //   
		SetBit(LCDPORT_DATA,LCDIN_BITEN); //  
		_delay_loop_2(8); //  2 
		numberdata_tmp|=PINK&240; //      LCD
		ClearBit(LCDPORT_DATA,LCDIN_BITEN); //  
		numberdata_tmp=LCD_SwapNibbles(numberdata_tmp); //   
		}
	while((numberdata_tmp&(1<<LCDOUT_BITWAIT))!=0); //      
	ClearBit(LCDPORT_DATA,LCDOUT_BITRW); //    LCD
	LCDPORT_DIRECT|=240; //   
	_delay_loop_2(160); //  40 
	}

void LCD_WriteCommon(byte numberdata_prm) //    LCD
	{
	LCD_WaitDevice(); //  LCD
	ClearBit(LCDPORT_DATA,LCDOUT_BITRS); //   
	LCD_CommonFunction(numberdata_prm); //    LCD
	}

void LCD_WriteData(byte numberdata_prm) //     LCD
	{
	LCD_WaitDevice(); //  LCD
	SetBit(LCDPORT_DATA,LCDOUT_BITRS); //   
	LCD_CommonFunction(numberdata_prm); //  
	}

void LCD_InitializeDevice(void) //    LCD
	{
	SYS_TimeWaiting(40); //  40 
	LCD_WriteCommon(8); //  LCD
	LCD_WriteCommon(40); //  4- ,  
	LCD_WriteCommon(1);  //  LCD
	SYS_TimeWaiting(2); //  2 
	LCD_WriteCommon(12);  //   LCD,   
	}

byte LCD_SwapNibbles(byte numberdata_prm) //   
	{
	asm volatile("swap %0":"=r"(numberdata_prm):"0"(numberdata_prm));
	return numberdata_prm;
	}

