/********************************************
* Outmessage.c
      
* : 20.02.2021 18:38:36
* :  .
*********************************************/

// 
#include <avr/io.h>
#include "Main.h"
#include "Outmessage.h"
#include "Symbolcharge.h"
#include "Lcdworkunit.h"
#include "Othercalibrations.h"

void OUT_CursorPosition(byte spotposition_prm,byte lineposition_prm) //  
	{
	LCD_GotoPosition(spotposition_prm,lineposition_prm); // 
	LCD_WriteCommon(14); //  
	}

void OUT_PinchipType(bit pinchiptype_prm) //   pin/chip 
	{
	LCD_GotoPosition(0,1); // 
	switch(pinchiptype_prm) //  
		{
		case FALSE: LCD_WriteData(1); // pin 
					break;
		case TRUE: LCD_WriteData(2); // chip 
		}
	}

void OUT_SystemTitle(void) //   
	{
	SYM_OutcharLine(0,0,0); // : RLC 
	SYM_OutcharLine(0,1,1); // : :2.1 2020 .
	}

void OUT_ResistanceTitle(void) //    
	{
	SYM_OutcharLine(1,0,0); // : R=   ,  
	SYM_OutcharLine(0,3,1); // : F=     ,  
	}

void OUT_CappacityTitle(void) //     1   
	{
	SYM_OutcharLine(2,0,0); // : C= ,    
	SYM_OutcharLine(0,3,1); // : F=     ,  
	}

void OUT_CapacityTitle(void) //      1 
	{
	SYM_OutcharLine(3,0,0); // : C=   ,  
	SYM_OutcharLine(0,5,1); // : F=       
	}

void OUT_InductanceTitle(void) //    
	{
	SYM_OutcharLine(4,0,0); // : L=  ,   
	SYM_OutcharLine(0,5,1); // : F=       
	}

void OUT_ArefdataTitle(void) //     
	{
	SYM_OutcharLine(5,0,0); // :      V=    
	SYM_OutcharLine(5,1,1); // : .      
	}

void OUT_VddrefdataTitle(void) //      Vdd
	{
	SYM_OutcharLine(5,0,0); // :      V=    
	SYM_OutcharLine(5,12,1); // : .VDD      
	}

void OUT_FrequpiezoTitle(bit indxonoffaudio_prm) //      
	{
	switch(indxonoffaudio_prm) // /  
		{
		case FALSE: SYM_OutcharLine(5,3,0); // :  .. .
					break;
		case TRUE: SYM_OutcharLine(5,2,0); // :  .. .
		}
	SYM_OutcharLine(5,4,1); // : .Fp      
	}

void OUT_Res12_18Title(void) //     12-18 
	{
	SYM_OutcharLine(5,5,0); // : R=   ,  
	SYM_OutcharLine(5,6,1); // : .R 12-18 
	}

void OUT_Res51_68Title(void) //     51-68 
	{
	SYM_OutcharLine(5,5,0); // : R=   ,  
	SYM_OutcharLine(5,7,1); // : .R 51-68 
	}

void OUT_Current3maTitle(void) //      3 
	{
	word dataresistance_tmp=0; // 
	SYM_OutcharLine(5,8,0); // : PWM=     I=  ,    
	SYM_OutcharLine(5,9,1); // : .I~3 	R=  ,  
	dataresistance_tmp=OTH_ReadResistancedata(FALSE); //   12  18 
	SYM_OutdataMeasure00_0(dataresistance_tmp,16,19,1); //   
	}

void OUT_Current10maTitle(void) //      10 
	{
	word dataresistance_tmp=0; // 
	SYM_OutcharLine(5,8,0); // : PWM=     I=  ,    
	SYM_OutcharLine(5,10,1); // : .I~10 	R=  ,  
	dataresistance_tmp=OTH_ReadResistancedata(TRUE); //   51  68 
	SYM_OutdataMeasure00_0(dataresistance_tmp,17,20,1); //   
	}

void OUT_Current50maTitle(void) //      50 
	{
	word dataresistance_tmp=0; // 
	SYM_OutcharLine(5,8,0); // : PWM=     I=  ,    
	SYM_OutcharLine(5,11,1); // : .I~50 	R=  ,  
	dataresistance_tmp=OTH_ReadResistancedata(FALSE); //   12  18 
	SYM_OutdataMeasure00_0(dataresistance_tmp,17,20,1); //   
	}

void OUT_DataRefcalibrate(word checkvoltage_prm,word refvoltage_prm) //      
	{
	SYM_OutdataMeasure0000((dword)checkvoltage_prm,10,0); //   
	SYM_OutdataMeasure0000((dword)refvoltage_prm,14,1); //  
	}

void OUT_DataFrequencypiezo(dword datafrequencypiezo_prm) //     
	{
	SYM_OutdataMeasure0000(datafrequencypiezo_prm,13,1); //   
	}

void OUT_DataRescalibrate(word dataresistance_prm) //    
	{
	SYM_OutdataMeasure000_0((dword)dataresistance_prm,7,11,0); //  
	}

void OUT_DataPwmcurrcalibrate(word valuepwmdata_prm,word valuecurrentdata_prm) //     
	{
	SYM_OutdataMeasure000(valuepwmdata_prm,6,0); //  
	SYM_OutdataMeasure00_000((dword)valuecurrentdata_prm,14,17,0); //  
	}























