/**************************************************
* Cappmeasure.c
*     1   
* : 18.02.2021 22:22:25
* :  .
***************************************************/

// 
#include <avr/io.h>
#include <util/delay_basic.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <avr/sfr_defs.h>
#include <math.h>
#include "Main.h"
#include "Cappmeasure.h"
#include "Symbolcharge.h"
#include "Systemcontrol.h"
#include "Outmessage.h"
#include "Esrmeasure.h"
#include "Connectmode.h"
#include "Resmeasure.h"

bit_capp indx_capp={0,0,0,0,0,0,0,0}; // 
var_capp alter_capp={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; // 

EEMEM static dword Capp_SupportCapacity=CAPPSUPPORT_CAPACITY; //   

ISR(INT3_vect) //     INT3
	{
	if(indx_capp.synchronization==TRUE) //   
		{
		if(alter_capp.countoverflowtimer>99) // z     
			{
			TCCR3B=0; //  3
			indx_capp.readydatameasure=TRUE; //    
			}
		else alter_capp.countintervalmeasure++; //    
		}
	else //   
		{
		if(alter_capp.countintervalmeasure>0) //   
			{
			TCCR3B=1; // 3    
			if(bit_is_set(TIFR3,TOV3)) SetBit(TIFR1,TOV3); //   3  
			SetBit(TIMSK3,TOIE3); //    3
			indx_capp.synchronization=TRUE; //  
			}
		else alter_capp.countintervalmeasure++; //   
		}
	}

ISR(INT4_vect) //     INT4
	{
	alter_capp.backupdatatimer=TCNT3; //  3
	alter_capp.backupoverflowtimer=alter_capp.countoverflowtimer; //    3
	ClearBit(EIMSK,INT4); //     INT4
	if(bit_is_set(EIFR,INTF5)) SetBit(EIFR,INTF5); //   INT5  
	SetBit(EIMSK,INT5); //     INT5
	}

ISR(INT5_vect) //     INT5
	{
	TCCR3B=0; //  3
	ClearBit(EIMSK,INT5); //     INT5
	indx_capp.readydatameasure=TRUE; //    
	}

ISR(TIMER3_OVF_vect) //     3
	{
	alter_capp.countoverflowtimer++; //   3
	if(alter_capp.countoverflowtimer>=1220) //   
		{
		TCCR3B=0; //  3
		indx_capp.readydatameasure=TRUE; //    
		indx_capp.datatimeoverflow=TRUE; //    
		}
	}

void CAPP_ConstantaMeasure(void) //  
	{
	floatpoint constantadata_tmp=0; // 
	constantadata_tmp=CAPPLOAD_RESISTANCE+2*CAPPTIME_RESISTANCE; //      
	constantadata_tmp=constantadata_tmp*log(2)*1000; //   
	alter_capp.constantadata=(ldword)constantadata_tmp; //    
	alter_capp.measuredatacapacity=0; //  
	alter_capp.measuredatafrequency=0;
	ESR_ReadThreshold(); //   
	SetBit(EICRA,ISC31); //      INT3
	SetBit(EICRB,ISC41); //      INT4
	SetBit(EICRB,ISC51); //      INT5
	}

byte CAPP_ReadCursorposition(bit indxplaceposition_prm) //    
	{
	byte cursorposition_tmp=0; // 
	switch(indxplaceposition_prm) // /
		{
		case FALSE: cursorposition_tmp=alter_capp.spotpositioncursor; //    
					break;
		case TRUE: cursorposition_tmp=alter_capp.linepositioncursor; //   
		}
	return cursorposition_tmp; //      
	}

void CAPP_ModeMeasure(bit initializemode_prm) //      1 
	{
	CAPP_DisplayMeasure(initializemode_prm); //   
	CAPP_CycleMeasure(); //  
	}

dword CAPP_DecoderLimit(ldword measuredata_prm,byte limitingvalue_prm) //   
	{
	ldword measuredata_tmp; // 
	measuredata_tmp=measuredata_prm; //  
	while(measuredata_tmp>9999) //   
		{
		if(alter_capp.countlimitmeasure<limitingvalue_prm) //    
			{
			alter_capp.countlimitmeasure++; //  
			measuredata_tmp/=10; //   10 
			}
		else break; //      
		}
	return (dword)measuredata_tmp; // 
	}

void CAPP_DisplayMeasure(bit initializemode_prm) //    
	{
	dword extrameasuredata_tmp=0; // 
	if(indx_capp.displaydatameasure==TRUE) //      
		{
		indx_capp.displaydatameasure=FALSE; // 
		if(initializemode_prm==TRUE) indx_capp.initializecappmode=TRUE; //      
		if((indx_capp.initializecappmode==TRUE)||(alter_capp.countlimitmeasure!=alter_capp.backuplimitmeasure)) //   
			{
			CAPP_InitializeLine(); //  
			}
		CAPP_MeasureDataview(); //  
		switch(alter_capp.countlineposition) //  
			{
			case 0 ... 1: switch(alter_capp.countlineaddition) //   
						{
						case 0: SYM_OutdataMeasure00000_0(alter_capp.measuredatafrequency,7,13,1); //  
								break;
						case 1: SYM_OutdataMeasure0000000_0(alter_capp.measuredataperiod,7,15,1); //  
								break;
						case 2: SYM_OutdataMeasure00_000(alter_capp.esrdatacapacity,7,10,1); //  ESR
								break;
						case 3: SYM_OutdataMeasure0_00000(alter_capp.lossescapacity,7,9,1); //  
								break;
						case 4: SYM_OutdataMeasure00000_0(alter_capp.qualitycapacity,7,13,1); //  
						}
					break;
			case 2: extrameasuredata_tmp=eeprom_read_dword(&Capp_SupportCapacity); //   
					SYM_OutdataMeasure0000000(extrameasuredata_tmp,13,1); //     
			}
		indx_capp.pinchiptypedevice=SYS_ReadtypePinchip(); //  pin/chip  
		OUT_PinchipType(indx_capp.pinchiptypedevice); //  
		if(alter_capp.countlimitmeasure>0) alter_capp.countlimitmeasure=0; //     
		}
	}

void CAPP_CycleMeasure(void) //   
	{
	ldword capacitydata_tmp=0; // 
	ldword reactivedata_tmp=0;
	if((indx_capp.readydatameasure==FALSE)&&(indx_capp.startcyclemeasure==FALSE)) //   
		{
		indx_capp.startcyclemeasure=TRUE; //   
		SYS_SwitchBlockmode(TRUE); //  
		CAPP_InitializeVariable(); // 
		CAPP_StartstopMeasure(TRUE); //  
		SYM_IndicationMeasure(TRUE); //  
		}
	else if((indx_capp.readydatameasure==TRUE)&&(indx_capp.startcyclemeasure==TRUE)) //   
		{
		CAPP_StartstopMeasure(FALSE); //  
		indx_capp.startcyclemeasure=FALSE; //   
		indx_capp.displaydatameasure=TRUE; //   
		SYM_IndicationMeasure(FALSE); //  
		SYS_SwitchBlockmode(FALSE); //  
		capacitydata_tmp=CAPP_ProcessMeasure(); //  
		if(capacitydata_tmp>0) reactivedata_tmp=CAPP_CalculationReactive(capacitydata_tmp); //       
		switch(indx_capp.capacityreactive) // /
			{
			case FALSE: alter_capp.measuredatacapacity=CAPP_DecoderLimit(capacitydata_tmp,4); //   
						break;
			case TRUE:  alter_capp.measuredatareactive=CAPP_DecoderLimit(reactivedata_tmp,1); //   
			}
		}
	}

void CAPP_InitializeLine(void) //   
	{
	if(indx_capp.initializecappmode==TRUE) indx_capp.initializecappmode=FALSE; //     
	if(alter_capp.countlimitmeasure!=alter_capp.backuplimitmeasure) alter_capp.backuplimitmeasure=alter_capp.countlimitmeasure; //      
	switch(indx_capp.capacityreactive) //  /
		{
		case FALSE: switch(alter_capp.backuplimitmeasure)  //    
						{
						case 0: SYM_OutcharLine(2,0,0); // : C= ,    
								break;
						case 1: SYM_OutcharLine(2,1,0); // : C=  ,   
								break;
						case 2: SYM_OutcharLine(2,2,0); // : C=   ,  
								break;
						case 3: SYM_OutcharLine(2,3,0); // : C= ,    
								break;
						case 4: SYM_OutcharLine(2,4,0); // : C=  ,   
						}
					break;
		case TRUE: switch(alter_capp.backuplimitmeasure) //     
						{
						case 0: SYM_OutcharLine(2,5,0); // : X=  ,   
								break;
						case 1: SYM_OutcharLine(2,6,0); // : X=   ,  
						}
		}
	}

void CAPP_MeasureDataview(void) //   
	{
	switch(indx_capp.capacityreactive) // /
		{
		case FALSE:	switch(alter_capp.backuplimitmeasure) //  
						{
						case 0: SYM_OutdataMeasure0_000(alter_capp.measuredatacapacity,7,9,0); //     0,000
								break;
						case 1: SYM_OutdataMeasure00_00(alter_capp.measuredatacapacity,7,10,0); //     00,00
								break;
						case 2: SYM_OutdataMeasure000_0(alter_capp.measuredatacapacity,7,11,0); //     000,0
								break;
						case 3: SYM_OutdataMeasure0_000(alter_capp.measuredatacapacity,7,9,0); //     0,000
								break;
						case 4: SYM_OutdataMeasure00_00(alter_capp.measuredatacapacity,7,10,0); //     00,00
						}
					break;
		case TRUE: switch(alter_capp.backuplimitmeasure) //  
						{
						case 0: SYM_OutdataMeasure00_00(alter_capp.measuredatareactive,7,10,0); //     00,00
								break;
						case 1: SYM_OutdataMeasure000_0(alter_capp.measuredatareactive,7,11,0); //     000,0
						}
		}
	}

void CAPP_InitializeVariable(void) //  
	{
	if(indx_capp.readydatameasure==TRUE) indx_capp.readydatameasure=FALSE; //      
	if(indx_capp.synchronization==TRUE) indx_capp.synchronization=FALSE; //    
	if(indx_capp.datatimeoverflow==TRUE) indx_capp.datatimeoverflow=FALSE; //    
	if(alter_capp.countoverflowtimer>0) alter_capp.countoverflowtimer=0; //     
	if(alter_capp.countintervalmeasure>0) alter_capp.countintervalmeasure=0; //      
	}

void CAPP_StartstopMeasure(bit indxstartstop_prm) //     
	{
	switch(indxstartstop_prm) // /
		{
		case FALSE: cli(); //  
					ClearBit(TIMSK3,TOIE3); //    3
					ClearBit(EIMSK,INT3); //     INT3
					indx_capp.readydatameasure=FALSE; //    
					break;
		case TRUE: if(alter_capp.measuredataperiod>0) alter_capp.measuredataperiod=0; // 
					if(alter_capp.measuredatafrequency>0) alter_capp.measuredatafrequency=0;
					TCNT3=0; // 3
					SetBit(EIMSK,INT3); //     INT3
					if(bit_is_set(EIFR,INTF3)) SetBit(EIFR,INTF3); //    
					sei(); //  
		}
	}

ldword CAPP_ProcessMeasure(void) //    
	{
	dword timedischargecapacity_tmp=0; // 
	dword proberesistance_tmp=0; 
	ldword capacitydata_tmp=0;
	if(indx_capp.datatimeoverflow==FALSE) capacitydata_tmp=CAPP_ResultsMeasure(); //     
	if(capacitydata_tmp>0) //     
		{
		timedischargecapacity_tmp=capacitydata_tmp*225/1000; //    
		alter_capp.esrdatacapacity=ESR_EsrdataCapacity(capacitydata_tmp,timedischargecapacity_tmp); // ESR 
		if(indx_capp.pinchiptypedevice==TRUE) //   
			{
			proberesistance_tmp=RES_ReadProberesistance(); //  
			if(alter_capp.esrdatacapacity>=proberesistance_tmp) alter_capp.esrdatacapacity-=proberesistance_tmp; // ESR       ESR
			else alter_capp.esrdatacapacity=0; // ESR  
			}
		alter_capp.lossescapacity=CAPP_LossesMeasure(capacitydata_tmp); //   
		alter_capp.qualitycapacity=CAPP_QualityMeasure(); //  
		}
	else //    
		{
		alter_capp.esrdatacapacity=0; //  ESR
		alter_capp.lossescapacity=0; //  
		alter_capp.qualitycapacity=0; //  
		}
	return capacitydata_tmp; //  
	}

ldword CAPP_ResultsMeasure(void) //    
	{
	ldword capacitydata_tmp=0; // 
	ldword frequencydata_tmp=0;
	frequencydata_tmp=CAPP_CalculationFrequency(); //  
	if(frequencydata_tmp<30000) //   3000 , ..    
		{
		if(SYS_ReadindxOnoffaudio()>0) SYS_OutsignalBeep(1); //   1 ,  
		alter_capp.measuredatafrequency=frequencydata_tmp; //   
		alter_capp.measuredataperiod=CAPP_CalculationPeriod(); //  
		capacitydata_tmp=CAPP_CalculationCapacity(); //  
		}
	else
		{
		if(alter_capp.measuredatafrequency>0) alter_capp.measuredatafrequency=0; //  
		if(alter_capp.measuredataperiod>0) alter_capp.measuredataperiod=0; //  
		capacitydata_tmp=0; //  
		}
	return capacitydata_tmp; //    
	}

ldword CAPP_CalculationFrequency(void) //  
	{
	ldword frequencydata_tmp=0; // 
	ldword periodmeasure_tmp=0;
	periodmeasure_tmp=CAPPRATIO_TIMER3*alter_capp.countoverflowtimer; //    
	periodmeasure_tmp+=(ldword)TCNT3; //   3
	frequencydata_tmp=(ldword)CAPPFREQU_CRYSTAL*alter_capp.countintervalmeasure*10/periodmeasure_tmp; // 
	return frequencydata_tmp; //  
	}

dword CAPP_CalculationPeriod(void) //  
	{
	ldword calculationperiod_tmp=0; // 
	calculationperiod_tmp=100000000/alter_capp.measuredatafrequency; // 
	return (dword)calculationperiod_tmp; //  
	}

ldword CAPP_CalculationCapacity(void) //  
	{
	ldword capacitydata_tmp=0; // 
	capacitydata_tmp=100000000000000000/(alter_capp.measuredatafrequency*alter_capp.constantadata); //  
	capacitydata_tmp-=eeprom_read_dword(&Capp_SupportCapacity); //  
	return capacitydata_tmp/1000; //    
	}

dword CAPP_CalculationReactive(ldword capacitydata_prm) //   
	{
	floatpoint intermediatedata_tmp=0; // 
	ldword reactancedata_tmp=0; 
	intermediatedata_tmp=2*M_PI*(floatpoint)alter_capp.measuredatafrequency*(floatpoint)capacitydata_prm; // 
	reactancedata_tmp=1000000000000/(ldword)intermediatedata_tmp; //       
	return (dword)reactancedata_tmp; //  
	}

dword CAPP_LossesMeasure(ldword capacitydata_prm) //    
	{
	floatpoint intermediatedata_tmp=0; // 
	dword lossescapacity_tmp=0;
	intermediatedata_tmp=2*M_PI*(floatpoint)alter_capp.measuredatafrequency*(floatpoint)capacitydata_prm*(floatpoint)alter_capp.esrdatacapacity; //  
	intermediatedata_tmp/=100000000; //  
	lossescapacity_tmp=(dword)intermediatedata_tmp; //     
	return lossescapacity_tmp; //  
	}

dword CAPP_QualityMeasure(void) //   
	{
	dword qualitycapacity_tmp=0; // 
	qualitycapacity_tmp=1000000/alter_capp.lossescapacity; //   
	return qualitycapacity_tmp; //  
	}

void CAPP_ControlMode(byte readoutcode_prm) //      
	{
	switch(readoutcode_prm) //   
		{
		case 1: switch(alter_capp.countlineposition) //      Left
					{
					case 0: if(alter_capp.countspotposition==0) alter_capp.countspotposition=1; //     
							else alter_capp.countspotposition=0; //     
							break;
					case 1: asm("nop"); //    
							break;
					case 2: if(alter_capp.countspotposition>1) alter_capp.countspotposition--; //      1    
							else alter_capp.countspotposition=5; //  5     1
					}
				break;
		case 2: switch(alter_capp.countlineposition) //       Rigt
					{
					case 0: if(alter_capp.countspotposition==0) alter_capp.countspotposition=1; //      
							else alter_capp.countspotposition=0; //   
							break;
					case 1: asm("nop"); //    
							break;
					case 2: alter_capp.countspotposition++; //       
							if(alter_capp.countspotposition>5) alter_capp.countspotposition=1; //  1     5
					}
				break;
		case 3: if(alter_capp.countspotposition==1) //      Up
					{
					if(alter_capp.countlineaddition==0) //   
						{
						alter_capp.countlineposition++; //  
						if(alter_capp.countlineposition>2) alter_capp.countlineposition=0; //    2
						CAPP_UpdateLine(); // 
						}
					else asm("nop"); //       
					}
				else CAPP_CorrectCalibrate(FALSE); //  
				break;
		case 4: if(alter_capp.countspotposition==1) //      Down
					{
					if(alter_capp.countlineaddition==0) //   
						{
						if(alter_capp.countlineposition>0) alter_capp.countlineposition--; //     
						else alter_capp.countlineposition=2; //   2  
						CAPP_UpdateLine(); // 
						}
					else asm("nop"); //       
					}
				else CAPP_CorrectCalibrate(TRUE); //  
				break;
		case 5: switch(alter_capp.countlineposition) //       Enter
					{
					case 0: if(indx_capp.capacityreactive==FALSE) indx_capp.capacityreactive=TRUE; //       
							else indx_capp.capacityreactive=FALSE; //      
							indx_capp.initializecappmode=TRUE; //      
							indx_capp.displaydatameasure=TRUE; //   
							break;
					case 1: alter_capp.countlineaddition++; //   
							if(alter_capp.countlineaddition>4) alter_capp.countlineaddition=0; //     
							switch(alter_capp.countlineaddition) //     
								{
								case 0: SYM_OutcharLine(0,3,1); // : F=     ,  
										break;
								case 1: SYM_OutcharLine(0,4,1); // : T=       ,  
										break;
								case 2: SYM_OutcharLine(2,7,1); // : ESR=  ,    
										break;
								case 3: SYM_OutcharLine(2,8,1); // : tg&= ,
										break;
								case 4: SYM_OutcharLine(2,9,1); // : Q=     ,
								}
							break;
					case 2: asm("nop"); // 
					}
		}
	switch(alter_capp.countlineposition) //  
		{
		case 0: alter_capp.linepositioncursor=0; //   
				switch(alter_capp.countspotposition) //   
					{
					case 0: alter_capp.spotpositioncursor=0; //        
							break;
					case 1: alter_capp.spotpositioncursor=5; //         /
					}
				break;
		case 1: alter_capp.linepositioncursor=1; //   
				alter_capp.spotpositioncursor=5; //       /
				break;
		case 2:	alter_capp.linepositioncursor=1; //   
				switch(alter_capp.countspotposition) //     
					{
					case 1: alter_capp.spotpositioncursor=9; //     
							break;
					case 2: alter_capp.spotpositioncursor=14; //     
							break;
					case 3: alter_capp.spotpositioncursor=15; //     
							break;
					case 4: alter_capp.spotpositioncursor=16; //     
							break;
					case 5: alter_capp.spotpositioncursor=17; //     
					}
		}
	}

void CAPP_UpdateLine(void) //    
	{
	switch(alter_capp.countlineposition)
		{
		case 0 ... 1: SYM_OutcharLine(0,3,1); // : F=     ,  
				break;
		case 2: SYM_OutcharLine(2,10,1); // : .Co     ,   
		}
	}

void CAPP_CorrectCalibrate(bit indxincdecdata_prm) //   
	{
	switch(alter_capp.countlineposition) // 
		{
		case 0 ... 1: asm("nop"); // 
				break;
		case 2:	CAPP_CorrectCapacity(indxincdecdata_prm); //   
				CAPP_ConstantaMeasure(); // 
		}
	}

void CAPP_CorrectCapacity(bit indxincdecdata_prm) //    
	{
	dword capacitydata_tmp=0; // 
	capacitydata_tmp=eeprom_read_dword(&Capp_SupportCapacity); //   
	switch(alter_capp.countspotposition) //   
		{
		case 1: asm("nop"); // 
				break;
		case 2: if(indxincdecdata_prm==FALSE) capacitydata_tmp+=100000; //   100000   
				else if((indxincdecdata_prm==TRUE)&&(capacitydata_tmp>100000)) capacitydata_tmp-=100000; //   100000   
				break;
		case 3: if(indxincdecdata_prm==FALSE) capacitydata_tmp+=10000; //   1000   
				else if((indxincdecdata_prm==TRUE)&&(capacitydata_tmp>10000)) capacitydata_tmp-=10000; //   10000   
				break;
		case 4: if(indxincdecdata_prm==FALSE) capacitydata_tmp+=1000; //   1000   
				else if((indxincdecdata_prm==TRUE)&&(capacitydata_tmp>1000)) capacitydata_tmp-=1000; //   1000   
				break;
		case 5: if(indxincdecdata_prm==FALSE) capacitydata_tmp+=100; //   100   
				else if((indxincdecdata_prm==TRUE)&&(capacitydata_tmp>100)) capacitydata_tmp-=100; //   100   
		}
	eeprom_update_dword(&Capp_SupportCapacity,capacitydata_tmp); //   
	}

dword CAPP_CycleEsrmeasure(ldword capacitydata_prm) //   ESR
	{
	byte currentindx_tmp=0; // 
	dword primintervaltime_tmp=0;
	dword secintervaltime_tmp=0;
	dword eqseriesresistance_tmp=0;
	if(capacitydata_prm>100000) //   100 
		{
		CON_SettingCurrent(3); //   50 
		currentindx_tmp=3; //   50 
		}
	else if((capacitydata_prm>10000)&&(capacitydata_prm<=100000)) //     100    10 
		{
		CON_SettingCurrent(2); //   10 
		currentindx_tmp=2; //   10 
		}
	else if(capacitydata_prm<=10000) //     10 
		{
		CON_SettingCurrent(1); //   3 
		currentindx_tmp=1; //   3 
		}
	if(bit_is_set(EIFR,INTF4)) SetBit(EIFR,INTF4); //   INT4  
	SetBit(EIMSK,INT4); //     INT4
	if(bit_is_set(TIFR3,TOV3)) SetBit(TIFR3,TOV3); //   3  
	SetBit(TIMSK3,TOIE3); //    3
	TCNT3=0; // 3
	CON_SwitchDevice(FALSE,6); //    
	TCCR3B=1; // 3    
	sei(); //  
	while(indx_capp.readydatameasure==FALSE); //   
	cli(); //  
	ClearBit(TIMSK3,TOIE3); //    3
	CON_SettingCurrent(0); //  
	indx_capp.readydatameasure=FALSE; // 
	if(alter_capp.backupoverflowtimer>0) primintervaltime_tmp=CAPPRATIO_TIMER3*alter_capp.backupoverflowtimer+(dword)alter_capp.backupdatatimer; //       
	else primintervaltime_tmp=(dword)alter_capp.backupdatatimer; //      
	if(alter_capp.countoverflowtimer>0) secintervaltime_tmp=CAPPRATIO_TIMER3*alter_capp.countoverflowtimer+(dword)TCNT3; //       
	else secintervaltime_tmp=(dword)TCNT3; //      
	eqseriesresistance_tmp=ESR_ProcessMeasure(currentindx_tmp,primintervaltime_tmp,secintervaltime_tmp); //   ESR
	return eqseriesresistance_tmp; //  
	}












