/********************************************************
* Resmeasure.h
*     
* : 20.02.2021 18:51:27
* :  .
*********************************************************/

#pragma once

#include "Main.h"

#define RESFREQU_CRYSTAL 16000000 //   
#define RESSUPPORT_CAPACITY 92400 //  9240,0  
#define RESALONG_RESISTANCE 56000000 //   560000,0 
#define RESLOAD_RESISTANCE 120000 //  1200,0 
#define RESTIME_RESISTANCE 200000 //  2000,0 
#define RESOFFSET_ZERO 7304 //  730,4 
#define RESPROBE_RESISTANCE 1 //    0,01 
#define RESCOMP_CONDUCTANCE 42000000 //  
#define RESTHRESHOLD_FREQU 141175 //  141,175 
#define RESRATIO_TIMER0 256 // 0
#define RESRATIO_TIMER1 65536 // 1

typedef struct
	{
	bit readydatameasure:1; //   
	bit startcyclemeasure:1; //   
	bit datatimeoverflow:1; //   
	bit displaydatameasure:1; //    
	bit pinchiptypedevice:1; //   pin/chip
	bit initializeresmode:1; //   
	bit resistanceconductance:1; //  /
	bit frequencyperiod:1; //  /
	}bit_res;

typedef struct
	{
	byte spotpositioncursor; //    
	byte linepositioncursor; //  
	byte countlineposition; //  
	byte countspotposition; //  
	byte countlimitmeasure; //  
	byte backuplimitmeasure; //  
	word countintervalmeasure; //  
	dword measuredataresistance; //   
	dword measuredataconductance; //  
	dword measuredataperiod; //  
	dword countoverflowtimer; //  
	ldword dataoffsetzero; //   
	ldword measuredatafrequency; //   
	ldword constantafrequency; //     
	ldword constantaresistance; //     
	}var_res;

void RES_ConstantaMeasure(void); //  
void RES_ModeMeasure(bit initializemode_prm); //   
void RES_DisplayModepoints(bit initializemode_prm); //    
void RES_InicializeLine(void); //      
void RES_MeasureDataview(void); //   
void RES_CycleMeasure(void); //  
void RES_InicializeVariable(void); //  
void RES_StartstopMeasure(bit indxstartstop_prm); //     
void RES_ControlMode(byte readoutcode_prm); //      
void RES_CorrectCapacity(bit indxincdecdata_prm); //     
void RES_CorrectConductance(bit indxincdecdata_prm); //     
void RES_CorrectProbe(bit indxincdecdata_prm); //     
void RES_UpdateLine(void); //   
void RES_CorrectCalibrate(bit indxincdecdata_prm); //   
void RES_ReadMeasuredata(bit readydatameasure_prm,bit datatimeoverflow_prm,word countintervalmeasure_prm,dword countoverflowtimer_prm); //   
void RES_StartstopMeasure(bit indxstartstop_prm); //     
void RES_DefineThresholdfrequ(void); //    
byte RES_ReadCursorposition(bit indxplaceposition_prm); //        
dword RES_DecoderLimit(ldword measurevalue_prm,byte limitingvalue_prm); //   
dword RES_CalculationPeriod(ldword frequencydata_prm); //  
dword RES_ReadProberesistance(void); //   
ldword RES_ProcessMeasure(void); //    
ldword RES_CalculationFrequency(void); //  
ldword RES_CalculationResistance(ldword frequencydata_prm); //  
ldword RES_CalculationConductance(ldword resistancedata_prm); //  
ldword RES_TotalCalculation(ldword frequencydata_prm); //   
ldword RES_CorrectMeasure(ldword resistancedata_prm); //   
ldword RES_MeasureOffset(void); //   
ldword RES_CompensacionData(ldword resistancedata_prm); //      
















