/*****************************************************************
* : RLC_Measurement.c
*   : 2.2
* : 15.01.2021 21:47:47
* :  .
* :   RLC  
* : ATMEGA2560
*  : 16000000 

FuseLOW=FF: CKDIV8=1;  
			CKOUT=1;    
			SUT1=1;   16K CK+65
			SUT0=1;
			CKSEL3=1;    8 
			CKSEL2=1;
			CKSEL1=1;
			CKSEL0=1;
FuseHIGH=9F:OCDEN=1;   
			JTAGEN=0;  JTAG    
			SPIEN=0;  SPI   
			WDTON=1;   
			EESAVE=1;   EEPROM
			BOOTSZ1=1;   512 
			BOOTSZ0=1;
			BOOTRST=1;      
FuseEXT=FD: BODLEVEL=101;   BOD 2,7 
******************************************************************/ 

#include <avr/io.h>
#include "Lcdworkunit.h"
#include "Systemcontrol.h"
#include "Outmessage.h"
#include "Adconverter.h"

int main(void)
	{
    DDRA=0; // 
    PORTA=31; // PA0-PA4   
    DDRE=0; // 
    PORTE=48; // PE4,PE5   
    DDRG=7; //PG0-PG2 ,  
    PORTG=4; // PG0,PG1 .0,  PG2 .1
    DDRH=96; //PH5,PH6 ,  
    PORTH=65; // PH5 .0,  PH6 .1,  PH0   
    DDRK=255; // 
    PORTK=1; // PK0 .1,   .0
    DDRL=127; //PL7 ,  
    PORTL=0; //   .0
    OCR2B=200; //      
    TCCR2A=35; // Fast PWM    
    TCCR2B=2; // 2  F_CPU/8, T=128  F=7,8125 
    LCD_InitializeDevice(); // LCD
    OUT_SystemTitle(); // 
    ADC_InitializeDevice(); // 
    SYS_InitializeBeep(); //  
    SYS_OutsignalBeep(10); //    10 
    SYS_TimeWaiting(2000); // 2 
	
    while(1) 
		{
		SYS_MainMode(); //   
		}
	}

